#!/usr/bin/env python

"""
insertComments.py
    
Thu Jan 26 00:44:04 CST 2006

This script is for use with Apples new iLife application iWeb.  After publishing
your blog to .Mac, open terminal and navigate to the blog folder on your iDisk
and run this script.

"""

import os, sys, re

haloscan_script = '<script type="text/javascript" src="http://www.haloscan.com/load/%s"></script>'
comments_insert_tag = 'InsertCommentsHere'
trackbacks_insert_tag = 'InsertTrackBacksHere'
comments_link = '<a href="javascript:HaloScan(\'%s\')" target="_self"><script type="text/javascript">postCount(\'%s\');</script></a>'
trackbacks_link = '<a href="javascript:HaloScanTB(\'%s\')" target="_self"><script type="text/javascript">postCountTB(\'%s\');</script></a>'

#re_comments_image = re.compile(r'<img src=".*?" longdesc="InsertCommentsHere" .*? />')
#re_trackbacks_image = re.compile(r'<img src=".*?" longdesc="InsertTrackBacksHere" .*? />')
re_comments_image = re.compile(r'(<img src=\"[-_//.a-zA-Z0-9]*\" longdesc="InsertCommentsHere" .*?/>)')
re_trackbacks_image = re.compile(r'(<img src=\"[-_//.a-zA-Z0-9]*\" longdesc="InsertTrackBacksHere" .*?/>)')
re_style = re.compile(r'style=".*?"')

def skipComments(uname, html):
    if uname == '':
	return True
    elif html.find(haloscan_script %uname) < 0 and ( html.find(comments_insert_tag) >=0 or html.find(trackbacks_insert_tag) >=0 ):
        skip = False
    else:
        skip = True
    return skip

def skipCounter(scode, html):
    if scode == '':
	return True
    elif html.find(scode) < 0:
	skip = False
    else:
	skip = True
    return skip

def addCounter(scode, html):
    start = html.find('<p align="center"><!-- Start of StatCounter Code -->')
    end = html.find('</body>')
    if start >= 0:
	html = html[0:start] + scode + html[end:]
    else:
	start = html.find('</body>')
	html = html[0:start] + scode + html[start:]
    return html

def addComments(fname, uname, html):
    #Insert Haloscan javascript loader
    start = html.find('</head>')
    html = html[0:start] + haloscan_script %uname + html[start:]
    
    #Insert Comments Link
    longdesc = html.find('longdesc="' + comments_insert_tag + '"')
    if longdesc>=0:
	image_string = re_comments_image.findall(html)
	if len(image_string) > 0:
	    image_string = image_string[0]
	    style = re_style.findall(image_string)
	    if len(style) > 0:
		style = style[0]
		insert_text = '<div %s>%s</div>' %(style, comments_link %(fname, fname))
		html = re_comments_image.sub(insert_text, html)
    else:
	html = html.replace(comments_insert_tag, comments_link %(fname, fname))
    
    #Insert TrackBacks Link
    longdesc = html.find('longdesc="' + trackbacks_insert_tag + '"')
    if longdesc>=0:
	image_string = re_trackbacks_image.findall(html)
	if len(image_string) > 0:
	    image_string = image_string[0]
	    style = re_style.findall(image_string)
	    if len(style) > 0:
		style = style[0]
		insert_text = '<div %s>%s</div>' %(style, trackbacks_link %(fname, fname))
		html = re_trackbacks_image.sub(insert_text, html)
    else:
	html = html.replace(trackbacks_insert_tag, trackbacks_link %(fname, fname))

    return html

def saveFile(fpath, html):
    os.remove(fpath)
    new_file = open(fpath, 'w')
    new_file.write(html)
    new_file.close()

def getFileList(top, walk):
    file_list = []
    if walk:
	for root, dirs, files in os.walk(top):
	    for fname in files:
		if fname.endswith('.html'):
		    file_list.append(os.path.join(root, fname))
    else:
	files = os.listdir(top)
	for fname in files:
	    if fname.endswith('.html'):
		file_list.append(os.path.join(top, fname))

    return file_list

if __name__=='__main__':

    import getopt

    try:
	opts, args = getopt.getopt(sys.argv[1:], 't:u:s:w')
    except getopt.error, msg:
	usage('Incorrect arguments')

    top = './'
    uname = ''
    scode = ''
    walk = False
    
    for o, a in opts:
	if o == '-t':
	    top = a
	if o == '-u':
	    uname = a
	if o == '-s':
	    scode = a
	if o == '-w':
	    walk = True
    
    files = getFileList(top, walk)

    if not scode == '':
	scode = '<p align="center">' + scode + '</p>'
    
    for fpath in files:
	fname = os.path.split(fpath)[-1]
        f = open(fpath)
        html = f.read()
	need_save = False
        if not skipComments(uname, html):
            html = addComments(fname, uname, html)
	    need_save = True
	if not skipCounter(scode, html):
	    html = addCounter(scode, html)
	    need_save = True
	if need_save:
            saveFile(fpath, html)
